package com.sourcebits.flickrhack;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.URLEncoder;
import java.util.ArrayList;
import java.util.List;

import org.apache.http.HttpResponse;
import org.apache.http.StatusLine;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import android.app.Activity;
import android.os.AsyncTask;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ListView;

public class FlickrActivity extends Activity {

	public static ArrayList<String> mID = new ArrayList<String>();

	public static String API_KEY = "ec369dd38a769dd4e2835985db1d3c8c";
	public static String SECRET_KEY = "ea035671f172c657";
	public static String mUrl;
	private String mKeyword;
	private String jsonResponse;

	private ListView listFlickr;

	private EditText editSearch;

	public static ArrayList<String> mSecret = new ArrayList<String>();
	public static ArrayList<String> mServer = new ArrayList<String>();
	public static ArrayList<String> mFarm = new ArrayList<String>();

	public static ArrayList<String> mPhotoUrl = new ArrayList<String>();

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_flickr);
		listFlickr = (ListView) findViewById(R.id.listView1);
		editSearch = (EditText) findViewById(R.id.editText1);
		

	}

	public void searchPics(View view) {
		mPhotoUrl.clear();
		mID.clear();
		mSecret.clear();
		mServer.clear();
		mFarm.clear();
		mKeyword = editSearch.getText().toString();
		String serverUrl = "http://api.flickr.com/services/rest/?method=flickr.photos.search";
		String photosPerPage = "&per_page=50";
		String nojsoncallback = "&nojsoncallback=1";
		String responce_format = "&format=json";
		String Query_tag =  mKeyword;
		String flickrApiKey = "&api_key=" + API_KEY;
		mUrl = serverUrl + photosPerPage + nojsoncallback + responce_format
				+ "&tags=" + URLEncoder.encode(Query_tag) + flickrApiKey;
		Log.v("URL Created", "" + mUrl);
		new FlickrFetch().execute();

	}

	class FlickrFetch extends AsyncTask<Void, Void, Void> {

		@Override
		protected Void doInBackground(Void... params) {
			parseJSON();
			return null;
		}

		@Override
		protected void onPostExecute(Void result) {

			Log.v("Response", "" + jsonResponse);
			Log.v("ID", "" + mID);
			Log.v("Secret", "" + mSecret);
			Log.v("Server", "" + mServer);
			Log.v("Farm", "" + mFarm);

			for (int i = 0; i < mID.size(); i++) {
				String photoUrl = "http://farm" + mFarm.get(i)
						+ ".static.flickr.com/" + mServer.get(i) + "/"
						+ mID.get(i) + "_" + mSecret.get(i) + "_m.jpg";
				mPhotoUrl.add(photoUrl);
			}

			ImageAdapter adapterFlickr = new ImageAdapter(FlickrActivity.this);
			listFlickr.setAdapter(adapterFlickr);
			super.onPostExecute(result);
		}

	}

	public String readFeed() {
		StringBuilder builder = new StringBuilder();
		HttpClient mClient = new DefaultHttpClient();
		HttpGet mGet = new HttpGet(mUrl);
		try {
			HttpResponse mResponse = mClient.execute(mGet);
			StatusLine mStatus = mResponse.getStatusLine();
			int mCode = mStatus.getStatusCode();
			Log.v("Code", "" + mCode);
			if (mCode == 200) {
				InputStream mFeed = mResponse.getEntity().getContent();
				BufferedReader reader = new BufferedReader(
						new InputStreamReader(mFeed));
				String mLine;
				while ((mLine = reader.readLine()) != null) {
					builder.append(mLine);
				}
			} else {

			}
		} catch (ClientProtocolException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		return builder.toString();
	}

	public void parseJSON() {
		jsonResponse = readFeed();

		// JSON Parsing we need ( ID , secret , server ,farm )
		try {
			JSONObject jsonObject = new JSONObject(jsonResponse);
			JSONObject json = jsonObject.getJSONObject("photos");
			JSONArray jsonArray = json.getJSONArray("photo");
			for (int i = 0; i < jsonArray.length(); i++) {
				JSONObject jsonPics = jsonArray.getJSONObject(i);

				mID.add(jsonPics.getString("id"));
				mSecret.add(jsonPics.getString("secret"));
				mServer.add(jsonPics.getString("server"));
				mFarm.add(jsonPics.getString("farm"));
			}
		} catch (JSONException e) {
			e.printStackTrace();
		}

	}

}
